import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Date;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class HelloWorld extends HttpServlet {

	Connection conn = null;
	Statement st = null;
	ResultSet rs = null;
	ResultSetMetaData rmd = null;
	String query = null;

	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}

	private void createConnection(PrintWriter out) throws
		InstantiationException, IllegalAccessException, ClassNotFoundException, SQLException {
		Class.forName("com.mysql.jdbc.Driver").newInstance();
		out.println("Driver Registration Successful<br>");
		conn = DriverManager.getConnection("jdbc:mysql://$HOST/$DB_NAME?user=$USERNAME&password=$PASSWORD"
				 + "&useLegacyDatetimeCode=false"
				 + "");

		out.println("Connection Successful<br>");
	}// End createConnection()

	private void runQuery(PrintWriter out) throws SQLException {
		st = conn.createStatement();
		query = "SELECT * FROM user";
		rs = st.executeQuery(query);
		rmd = rs.getMetaData();
		out.println("<br>MetaData (# of Columns): " + rmd.getColumnCount() + "<br>");

		while (rs.next()) {
			String user = rs.getString("User");
			out.println("User = " + user + "<br>");
		}
	}// end runQuery()

	/** Processes requests for both HTTP GET and POST methods. */
	protected void processRequest(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		resp.setContentType("text/html");
		PrintWriter out = resp.getWriter();

		out.println("<html>");
		out.println("<body>");
		out.println("<h1>Test Database Connectivity</h1>");
		try {
			createConnection(out);
			runQuery(out);
		} catch (Exception sqe) {
			out.println("Caught SQLException from runQuery(): " + sqe);
			sqe.printStackTrace();
		}
		out.println("<br><br><hr>" + new Date().toString());
		out.println("</body>");
		out.println("</html>");
		out.close();
	}

	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		processRequest(req, resp);
	}
	protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, java.io.IOException {
		processRequest(req, resp);
	}
	public String getServletInfo() {
		return "Short description";
	}
	public void init() throws ServletException {
	}
	public void destroy() {
	}

}